| KD SOAP 1.9.1

Public Member Functions | List of all members
KDSoapServerObjectInterface Class Reference

`#include <KDSoapServerObjectInterface.h>`

## Public Member Functions
| KDSoapServerObjectInterface ()
virtual | ~KDSoapServerObjectInterface ()
virtual void | processRequest (const KDSoapMessage &request, KDSoapMessage &response, const QByteArray &soapAction)
virtual QIODevice * | processFileRequest (const QString &path, QByteArray &contentType)
virtual void | processRequestWithPath (const KDSoapMessage &request, KDSoapMessage &response, const QByteArray &soapAction, const QString &path)
virtual HttpResponseHeaderItems | additionalHttpResponseHeaderItems () const
void | doneProcessingRequestWithPath (const KDSoapServerObjectInterface &otherInterface)
KDSoapHeaders | requestHeaders () const
QByteArray | soapAction () const
void | setResponseHeaders (const KDSoapHeaders &headers)
void | setResponseNamespace (const QString &ns)
void | setFault (const QString &faultCode, const QString &faultString, const QString &faultActor=QString(), const QString &detail=QString())
void | setFault (const QString &faultCode, const QString &faultString, const QString &faultActor, const KDSoapValue &detail)
bool | hasFault () const
QAbstractSocket * | serverSocket () const
KDSoapDelayedResponseHandle | prepareDelayedResponse ()
bool | isDelayedResponse () const
void | sendDelayedResponse (const KDSoapDelayedResponseHandle &responseHandle, const KDSoapMessage &response)
void | writeHTTP (const QByteArray &httpReply)
void | writeXML (const QByteArray &reply, bool isFault=false)

## Detailed Description

Base class for server objects, i.e. objects implementing the methods that can be called by SOAP clients.

Your server object must derive from both QObject (directly or indirectly) and from KDSoapServerObjectInterface. The virtual method processRequest is called whenever a SOAP request is being made. To handle the call, either reimplement processRequest and do the dispatching manually (not recommended), or use kdwsdl2cpp to generate the base class for your server object.

Example: `class EmployeeServerObject : public MyServerBase // base class generated from the wsdl file { Q_OBJECT`

`public: // methods published to SOAP QString getEmployeeCountry(const QString& employeeName); [...] };`

The generated base class provides the pure virtual methods for each method defined in the WSDL file, such as getEmployeeCountry() in this example, as well as a generated processRequest() method which calls getEmployeeCountry when parsing a KDSoapMessage that is a "getEmployeeCountry" request.

Multi-threading note: KDSoapServer will create one instance of a "server object" per thread. So the code in this class does not need to be protected for thread-safety. Make sure to protect any shared resources though.

## Constructor & Destructor Documentation

## ◆ KDSoapServerObjectInterface()

KDSoapServerObjectInterface::KDSoapServerObjectInterface | ( |  | ) |

Constructor

## ◆ ~KDSoapServerObjectInterface()

KDSoapServerObjectInterface::~KDSoapServerObjectInterface | ( |  | ) |
| virtual

Destructor

## Member Function Documentation

## ◆ processRequest()

void KDSoapServerObjectInterface::processRequest | ( | const KDSoapMessage & | request,
|  | KDSoapMessage & | response,
|  | const QByteArray & | soapAction
| ) |  |
| virtual

Handle `request` and return `response`. The default implementation in this base class is to simply return a fault "method not found". Subclasses must implement the dispatching to actual implementation methods.

This method is called when calls are made to the default path for the server, as configured in KDSoapServer. For other paths, see processRequestWithPath().

When using kdwsdl2cpp to generate the server-side code, this is the method that will be generated, so that you don't have to implement it, only the pure virtual methods called by processRequest.

## ◆ processFileRequest()

QIODevice * KDSoapServerObjectInterface::processFileRequest | ( | const QString & | path,
|  | QByteArray & | contentType
| ) |  |
| virtual

Handle an HTTP GET request, typically by returning a file.

If a NULL device is returned by this method, a 404 error will be returned to the client.

Parameters

  path | the HTTP path sent by the client (this could also include a fragment and/or a query, see QUrl)
  contentType | output variable, your method should set it to the content type header to send back with the file. For instance "text/plain" for a plain text file.

Returns
  an iodevice for reading from. For instance a new QFile. KDSoap will delete the iodevice after reading all its contents.

Since
  1.3

## ◆ processRequestWithPath()

void KDSoapServerObjectInterface::processRequestWithPath | ( | const KDSoapMessage & | request,
|  | KDSoapMessage & | response,
|  | const QByteArray & | soapAction,
|  | const QString & | path
| ) |  |
| virtual

Handle a SOAP request that was sent to a different path than the one configured in KDSoapServer.

Parameters

  request | the incoming SOAP request
  response | the SOAP response to be sent back
  soapAction | the SOAP action string sent by the client
  path | the HTTP path sent by the client (this could also include a fragment and/or a query, see QUrl)

Note that a GET request with Accept="application/soap+xml" will trigger a call to this method with an empty incoming soap request, in order to make it possible to return SOAP responses. This is as documented in https://www.ibm.com/developerworks/xml/library/x-tipgetr/.

The default implementation in this base class is to simply return a fault "method not found". Subclasses must implement the dispatching to actual implementation methods. Usually this will be done by calling processRequest on other KDSoapServerObjectInterface instances, for instance generated by kdwsdl2cpp.

Since
  1.3

## ◆ additionalHttpResponseHeaderItems()

KDSoapServerObjectInterface::HttpResponseHeaderItems KDSoapServerObjectInterface::additionalHttpResponseHeaderItems | ( |  | ) | const
| virtual

Returns additional HTTP response header items to be added to each HTTP response header The default implementation in this base class returns an empty list Subclasses can override this method as needed

Since
  1.8

## ◆ doneProcessingRequestWithPath()

void KDSoapServerObjectInterface::doneProcessingRequestWithPath | ( | const KDSoapServerObjectInterface & | otherInterface | ) |

Call this after processRequestWithPath has finished handling a request, in order to copy response headers, faults, etc. from the secondary object interface into this one.

Since
  1.4

## ◆ requestHeaders()

KDSoapHeaders KDSoapServerObjectInterface::requestHeaders | ( |  | ) | const

Returns the SOAP headers that were provided together with the SOAP request. This can be used to retrieve authentication headers, or any kind of session (per-client) data.

## ◆ soapAction()

QByteArray KDSoapServerObjectInterface::soapAction | ( |  | ) | const

Returns the "Soap Action" header sent by the client.

## ◆ setResponseHeaders()

void KDSoapServerObjectInterface::setResponseHeaders | ( | const KDSoapHeaders & | headers | ) |

Sets the soap headers to be sent in the response

## ◆ setResponseNamespace()

void KDSoapServerObjectInterface::setResponseNamespace | ( | const QString & | ns | ) |

Sets the message namespace to be used in the response. If the requests comes with a message namespace("qualified"), then this can be determined from that namespace. But if the request is not qualified, this is very much necessary (at least when the response has headers, which are always qualified).

Since
  1.2

## ◆ setFault() [1/2]

void KDSoapServerObjectInterface::setFault | ( | const QString & | faultCode,
|  | const QString & | faultString,
|  | const QString & | faultActor = `QString()`,
|  | const QString & | detail = `QString()`
| ) |  |

Instructs KD SOAP to return a fault message instead of the return value of the slot.

Parameters

  faultCode | A code for identifying the fault. Example: "Server.EntryNotFound", or "Client.Authentication". Must not be empty.
  faultString | A human-readable explanation of the fault
  faultActor | Information about who caused the fault to happen
  detail | Holds application-specific error information related to the Body element

See https://www.w3.org/TR/2000/NOTE-SOAP-20000508/#_Toc478383507 for more details.

## ◆ setFault() [2/2]

void KDSoapServerObjectInterface::setFault | ( | const QString & | faultCode,
|  | const QString & | faultString,
|  | const QString & | faultActor,
|  | const KDSoapValue & | detail
| ) |  |

Instructs KD SOAP to return a fault message instead of the return value of the slot.

Parameters

  faultCode | A code for identifying the fault. Example: "Server.EntryNotFound", or "Client.Authentication". Must not be empty.
  faultString | A human-readable explanation of the fault
  faultActor | Information about who caused the fault to happen
  detail | Holds application-specific error information related to the Body element, it is given as a KDSoapValue and hence can be parsed

See https://www.w3.org/TR/2000/NOTE-SOAP-20000508/#_Toc478383507 for more details.

## ◆ hasFault()

bool KDSoapServerObjectInterface::hasFault | ( |  | ) | const

Returns true if setFault was called in the current method invocation.

## ◆ serverSocket()

QAbstractSocket * KDSoapServerObjectInterface::serverSocket | ( |  | ) | const

Returns a pointer to the server socket. Only valid during processRequest(). This can be used to retrieve information from the server socket, such as peerAddress etc.

Since
  1.3

## ◆ prepareDelayedResponse()

KDSoapDelayedResponseHandle KDSoapServerObjectInterface::prepareDelayedResponse | ( |  | ) |

When a server object wants to implement a SOAP method call using an asynchronous operation (I/O or network for instance), it should call prepareDelayedResponse() from within the call handler, store the handle, return a dummy value (this allows to go back to the event loop), and use the handle later on (typically from a slot) in order to send the delayed response.

Since
  1.2

## ◆ isDelayedResponse()

bool KDSoapServerObjectInterface::isDelayedResponse | ( |  | ) | const

Returns true if prepareDelayedResponse was called, during this soap call. Mostly useful internally in KDSoap.

Since
  1.2

## ◆ sendDelayedResponse()

void KDSoapServerObjectInterface::sendDelayedResponse | ( | const KDSoapDelayedResponseHandle & | responseHandle,
|  | const KDSoapMessage & | response
| ) |  |

Send a delayed response.

Parameters

  responseHandle | the identifier of the call we are responding to
  response | the response message for that call

Since
  1.2

## ◆ writeHTTP()

void KDSoapServerObjectInterface::writeHTTP | ( | const QByteArray & | httpReply | ) |

Low-level method, not needed for normal operations. Call this method to write an HTTP reply back, e.g. in case of an error. Example: writeHTTP("HTTP/1.1 404 Not Found\r\nContent-Length: 0\r\n\r\n");

Since
  1.5

## ◆ writeXML()

void KDSoapServerObjectInterface::writeXML | ( | const QByteArray & | reply,
|  | bool | isFault = `false`
| ) |  |

Low-level method, not needed for normal operations. Call this method to write an XML reply back. KDSoapServer will take care of the necessary HTTP headers.

Parameters

  reply | the SOAP reply in XML
  isFault | true if the reply is a fault (which means sending back the HTTP error code 500, as per the specification)

Since
  1.5

The documentation for this class was generated from the following files:

- src/KDSoapServer/KDSoapServerObjectInterface.h
- src/KDSoapServer/KDSoapServerObjectInterface.cpp

Klarälvdalens Datakonsult AB (KDAB)
"The Qt, C++ and OpenGL Experts"
https://www.kdab.com/
https://www.kdab.com/development-resources/qt-tools/kd-soap/